extends Area

var power = 0
export var acceleration = 1
var target_timer = 3.0

var room_area
var target_object = null
	
	
func _fixed_process(delta):
	if power < 10:
		power += acceleration * delta
		
	if not target_object:
		var objects = []
		for object in get_overlapping_bodies():
			if object.is_in_group("Objects") and get_parent().is_a_parent_of(object):
				objects.push_back(object)
				
		target_object = objects[ randi() % objects.size() ]
		target_object.set_mode( RigidBody.MODE_RIGID )
		
		target_timer = 3.0
		
	if target_object in get_node("Core").get_overlapping_bodies() or target_timer <= 0:
		target_object.reset()
		target_object = null
	else:
		target_timer -= delta
		var pos = get_translation()
		var obj_pos = target_object.get_translation()
		target_object.apply_impulse( Vector3( 0, rand_range(-0.1, 0.1), 0 ), ( pos - obj_pos ).normalized() * ( 5  - pos.distance_to(obj_pos) ) * power * delta )
	
	var character = get_tree().get_nodes_in_group("Character")[0]
	if character in get_node("Core").get_overlapping_bodies():
		character.hit()
	var pos = get_translation()
	var character_pos = character.get_translation()
	var vector_to = ( pos - character_pos ).normalized()
	character.move( Vector3(vector_to.x, 0, vector_to.z).normalized() * ( 10 - pos.distance_to(character_pos) ) * power/16 * delta )
	
func change_mode(mode):
	if mode == "depressive":
		get_node("Sprite3D/AnimationPlayer").play("Pulse")
		
		var character = get_tree().get_nodes_in_group("Character")[0]
		var pos = get_translation()
		var character_pos = character.get_translation()
		var vector_to = ( character_pos - pos ).normalized()
		character.apply_force( Vector3(vector_to.x, 0, vector_to.z) * 2 )
		
		var timer = Timer.new()
		timer.set_wait_time(0.2)
		add_child(timer)
		timer.start()
		
		yield(timer, "timeout")
		set_fixed_process(true)
		show()
	else:
		for object in get_parent().get_children():
			if object.is_in_group("Objects"):
				object.reset()
		power = 0
		set_fixed_process(false)
		hide()
