extends KinematicBody


signal dead

func _fixed_process(delta):
#	var rigid_objects = []
#	for object in get_tree().get_nodes_in_group("Objects"):
#		if object extends RigidBody and object.get_mode() == RigidBody.MODE_RIGID:
#			rigid_objects.push_back(object)
#	print( rigid_objects )
	
	var velocity = Vector3()
	if (Input.is_action_pressed("up")):
		velocity.z = -delta
	elif (Input.is_action_pressed("down")):
		velocity.z = delta
		
	if (Input.is_action_pressed("left")):
		velocity.x = -delta
	elif (Input.is_action_pressed("right")):
		velocity.x = delta
	
	velocity = velocity.normalized() * 5.0
	
	if velocity != Vector3():
		get_node("Body").set_transform( Transform().rotated( Vector3(0,1,0), -Vector2(velocity.x, velocity.z).angle() ) )
		if get_node("AnimationPlayer").get_current_animation() != "Walk":
			get_node("AnimationPlayer").play("Walk", 0.1)
	else:
		if get_node("AnimationPlayer").get_current_animation() != "Idle":
			get_node("AnimationPlayer").play("Idle", 0.1)
	
	var motion = move(velocity * delta)
	if is_colliding():
        var n = get_collision_normal()
        motion = n.slide(motion)
        move(motion)

func _ready():
	get_node("/root/Scene").connect("mode_changed", self, "change_mode")
	connect( "dead", get_node("/root/Scene"), "end" )
	
	set_fixed_process(true)
	
func apply_force( vector ):
	var knock = Knock.new()
	knock.vector = vector
	add_child(knock)
	
func change_mode(mode):

	for area in get_tree().get_nodes_in_group("Room Areas"):
		if mode == "depressive":
			if self in area.get_overlapping_bodies():
				if area.has_node("Black Hole"):
					area.get_node("Black Hole").change_mode(mode)
				
				break
		else:
			if area.has_node("Black Hole"):
				area.get_node("Black Hole").change_mode(mode)
			
func hit():
	emit_signal('dead')

class Knock extends Node:
	var vector = Vector3()
	var magnitude = 0.5
	
	func _ready():
		set_fixed_process( true )
		
	func _fixed_process(delta):
		var motion = get_parent().move( vector * magnitude )
		
		if get_parent().is_colliding():
	        var n = get_parent().get_collision_normal()
	        motion = n.slide(motion)
	        get_parent().move(motion)
		magnitude -= 3 * 0.5 * delta
		
		if magnitude < 0:
			queue_free()