extends StaticBody

export var manic_color = Color()
export var depressive_color = Color()

var saved_mode = "manic"

onready var material = get_node("MeshInstance").get_material_override().duplicate()


func _ready():
	get_node("/root/Scene").connect("mode_changed", self, "change_mode")
	
	get_node("MeshInstance").set_material_override( material )
	material.set_parameter( FixedMaterial.PARAM_DIFFUSE, manic_color )
		

	
func material_change(color):
	material.set_parameter( FixedMaterial.PARAM_DIFFUSE, color )

func change_mode(mode):
	saved_mode = mode
	
	var color
	if mode == "manic":
		color = manic_color
	else:
		color = depressive_color
	
	
	var tween = Tween.new()
	tween.interpolate_method( self, "material_change", material.get_parameter( FixedMaterial.PARAM_DIFFUSE ), color, 0.4, Tween.TRANS_SINE, Tween.EASE_OUT_IN)
	add_child(tween)
	tween.start()
	
	yield(tween, "tween_complete")
	tween.queue_free()