extends WorldEnvironment

signal mode_changed(mode)

export var manic_time = 10
export var depressive_time = 5

var mode = "manic"
var goal

func _ready():
	set_process_input(true)
	
	if not Music.is_playing():
		Music.play()
		
	connect("mode_changed", Music, "change_mode")
	
	var objects = get_tree().get_nodes_in_group("Objects")
	while true:
		randomize()
		goal = objects[ randi() % objects.size() ]
		if not goal extends RigidBody:
			objects.remove( objects.find(goal) )
		else:
			goal.make_goal()
			break
	
	var timer = Timer.new()
	add_child(timer)
	
	while true:
		timer.set_wait_time(manic_time)
		timer.start()
		
		yield(timer, "timeout")
		emit_signal("mode_changed", "depressive")
		
		timer.set_wait_time(depressive_time)
		timer.start()
		
		yield(timer, "timeout")
		emit_signal("mode_changed", "manic")
	
func _input(event):
	if OS.is_debug_build() and event.is_action_pressed("debug_mode_test") and not event.is_echo():
		if mode == "manic":
			mode = "depressive"
			emit_signal("mode_changed", "depressive")
		else:
			mode = "manic"
			emit_signal("mode_changed", "manic")
	elif event.is_action_pressed("exit"):
		get_tree().quit()
	
func end():
#	get_tree().quit()
	get_node("/root/").add_child( preload("res://Game Over.tscn").instance() )
	
func next_day():
	get_tree().reload_current_scene()
	Game.day += 1